/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing updating a handle.
    /// </summary>
    [DataContract(Name = "HandleValueForUpdateDto")]
    public partial class HandleValueForUpdateDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="HandleValueForUpdateDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected HandleValueForUpdateDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="HandleValueForUpdateDto" /> class.
        /// </summary>
        /// <param name="type">The data type of the handle. (required).</param>
        /// <param name="parsedData">The parsed data of the handle. (required).</param>
        /// <param name="idx">The id of the handle..</param>
        public HandleValueForUpdateDto(string type = default(string), Object parsedData = default(Object), int idx = default(int))
        {
            // to ensure "type" is required (not null)
            if (type == null)
            {
                throw new ArgumentNullException("type is a required property for HandleValueForUpdateDto and cannot be null");
            }
            this.Type = type;
            // to ensure "parsedData" is required (not null)
            if (parsedData == null)
            {
                throw new ArgumentNullException("parsedData is a required property for HandleValueForUpdateDto and cannot be null");
            }
            this.ParsedData = parsedData;
            this.Idx = idx;
        }

        /// <summary>
        /// The data type of the handle.
        /// </summary>
        /// <value>The data type of the handle.</value>
        [DataMember(Name = "type", IsRequired = true, EmitDefaultValue = true)]
        public string Type { get; set; }

        /// <summary>
        /// The parsed data of the handle.
        /// </summary>
        /// <value>The parsed data of the handle.</value>
        [DataMember(Name = "parsed_data", IsRequired = true, EmitDefaultValue = true)]
        public Object ParsedData { get; set; }

        /// <summary>
        /// The id of the handle.
        /// </summary>
        /// <value>The id of the handle.</value>
        [DataMember(Name = "idx", EmitDefaultValue = false)]
        public int Idx { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class HandleValueForUpdateDto {\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  ParsedData: ").Append(ParsedData).Append("\n");
            sb.Append("  Idx: ").Append(Idx).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
