/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a data transfer object (DTO) for a PID (Persistent Identifier).
    /// </summary>
    [DataContract(Name = "PidDto")]
    public partial class PidDto : IValidatableObject
    {

        /// <summary>
        /// Gets or Sets Type
        /// </summary>
        [DataMember(Name = "type", EmitDefaultValue = false)]
        public PidType? Type { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="PidDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected PidDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="PidDto" /> class.
        /// </summary>
        /// <param name="prefix">Gets or sets the prefix of the PID. (required).</param>
        /// <param name="suffix">Gets or sets the suffix of the PID. (required).</param>
        /// <param name="type">type.</param>
        /// <param name="isEntityValid">Gets or sets a value indicating whether the linked entity is considered valid..</param>
        public PidDto(string prefix = default(string), string suffix = default(string), PidType? type = default(PidType?), bool isEntityValid = default(bool))
        {
            // to ensure "prefix" is required (not null)
            if (prefix == null)
            {
                throw new ArgumentNullException("prefix is a required property for PidDto and cannot be null");
            }
            this.Prefix = prefix;
            // to ensure "suffix" is required (not null)
            if (suffix == null)
            {
                throw new ArgumentNullException("suffix is a required property for PidDto and cannot be null");
            }
            this.Suffix = suffix;
            this.Type = type;
            this.IsEntityValid = isEntityValid;
        }

        /// <summary>
        /// Gets or sets the prefix of the PID.
        /// </summary>
        /// <value>Gets or sets the prefix of the PID.</value>
        [DataMember(Name = "prefix", IsRequired = true, EmitDefaultValue = true)]
        public string Prefix { get; set; }

        /// <summary>
        /// Gets or sets the suffix of the PID.
        /// </summary>
        /// <value>Gets or sets the suffix of the PID.</value>
        [DataMember(Name = "suffix", IsRequired = true, EmitDefaultValue = true)]
        public string Suffix { get; set; }

        /// <summary>
        /// Gets the constructed PID by combining the prefix and suffix (\&quot;{Prefix}/{Suffix}\&quot;).
        /// </summary>
        /// <value>Gets the constructed PID by combining the prefix and suffix (\&quot;{Prefix}/{Suffix}\&quot;).</value>
        [DataMember(Name = "identifier", EmitDefaultValue = false)]
        public string Identifier { get; private set; }

        /// <summary>
        /// Returns false as Identifier should not be serialized given that it's read-only.
        /// </summary>
        /// <returns>false (boolean)</returns>
        public bool ShouldSerializeIdentifier()
        {
            return false;
        }
        /// <summary>
        /// Gets or sets a value indicating whether the linked entity is considered valid.
        /// </summary>
        /// <value>Gets or sets a value indicating whether the linked entity is considered valid.</value>
        [DataMember(Name = "isEntityValid", EmitDefaultValue = true)]
        public bool IsEntityValid { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class PidDto {\n");
            sb.Append("  Prefix: ").Append(Prefix).Append("\n");
            sb.Append("  Suffix: ").Append(Suffix).Append("\n");
            sb.Append("  Identifier: ").Append(Identifier).Append("\n");
            sb.Append("  Type: ").Append(Type).Append("\n");
            sb.Append("  IsEntityValid: ").Append(IsEntityValid).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
