/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) for resolving a project invitation.
    /// </summary>
    [DataContract(Name = "ProjectInvitationResolveDto")]
    public partial class ProjectInvitationResolveDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectInvitationResolveDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected ProjectInvitationResolveDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectInvitationResolveDto" /> class.
        /// </summary>
        /// <param name="token">Gets or initializes the token associated with resolving the project invitation. (required).</param>
        public ProjectInvitationResolveDto(Guid token = default(Guid))
        {
            this.Token = token;
        }

        /// <summary>
        /// Gets or initializes the token associated with resolving the project invitation.
        /// </summary>
        /// <value>Gets or initializes the token associated with resolving the project invitation.</value>
        [DataMember(Name = "token", IsRequired = true, EmitDefaultValue = true)]
        public Guid Token { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ProjectInvitationResolveDto {\n");
            sb.Append("  Token: ").Append(Token).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
