/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents a data transfer object (DTO) containing quota information for a project.
    /// </summary>
    [DataContract(Name = "ProjectQuotaDto")]
    public partial class ProjectQuotaDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ProjectQuotaDto" /> class.
        /// </summary>
        /// <param name="projectId">Identifier of the project..</param>
        /// <param name="totalUsed">totalUsed.</param>
        /// <param name="totalReserved">totalReserved.</param>
        /// <param name="allocated">allocated.</param>
        /// <param name="maximum">maximum.</param>
        /// <param name="resourceType">resourceType.</param>
        /// <param name="resourceQuotas">Quota information for individual resources of the selected project&#39;s resource type..</param>
        public ProjectQuotaDto(Guid projectId = default(Guid), QuotaDto totalUsed = default(QuotaDto), QuotaDto totalReserved = default(QuotaDto), QuotaDto allocated = default(QuotaDto), QuotaDto maximum = default(QuotaDto), ResourceTypeMinimalDto resourceType = default(ResourceTypeMinimalDto), List<ResourceQuotaDto> resourceQuotas = default(List<ResourceQuotaDto>))
        {
            this.ProjectId = projectId;
            this.TotalUsed = totalUsed;
            this.TotalReserved = totalReserved;
            this.Allocated = allocated;
            this.Maximum = maximum;
            this.ResourceType = resourceType;
            this.ResourceQuotas = resourceQuotas;
        }

        /// <summary>
        /// Identifier of the project.
        /// </summary>
        /// <value>Identifier of the project.</value>
        [DataMember(Name = "projectId", EmitDefaultValue = false)]
        public Guid ProjectId { get; set; }

        /// <summary>
        /// Gets or Sets TotalUsed
        /// </summary>
        [DataMember(Name = "totalUsed", EmitDefaultValue = false)]
        public QuotaDto TotalUsed { get; set; }

        /// <summary>
        /// Gets or Sets TotalReserved
        /// </summary>
        [DataMember(Name = "totalReserved", EmitDefaultValue = false)]
        public QuotaDto TotalReserved { get; set; }

        /// <summary>
        /// Gets or Sets Allocated
        /// </summary>
        [DataMember(Name = "allocated", EmitDefaultValue = false)]
        public QuotaDto Allocated { get; set; }

        /// <summary>
        /// Gets or Sets Maximum
        /// </summary>
        [DataMember(Name = "maximum", EmitDefaultValue = false)]
        public QuotaDto Maximum { get; set; }

        /// <summary>
        /// Gets or Sets ResourceType
        /// </summary>
        [DataMember(Name = "resourceType", EmitDefaultValue = false)]
        public ResourceTypeMinimalDto ResourceType { get; set; }

        /// <summary>
        /// Quota information for individual resources of the selected project&#39;s resource type.
        /// </summary>
        /// <value>Quota information for individual resources of the selected project&#39;s resource type.</value>
        [DataMember(Name = "resourceQuotas", EmitDefaultValue = true)]
        public List<ResourceQuotaDto> ResourceQuotas { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class ProjectQuotaDto {\n");
            sb.Append("  ProjectId: ").Append(ProjectId).Append("\n");
            sb.Append("  TotalUsed: ").Append(TotalUsed).Append("\n");
            sb.Append("  TotalReserved: ").Append(TotalReserved).Append("\n");
            sb.Append("  Allocated: ").Append(Allocated).Append("\n");
            sb.Append("  Maximum: ").Append(Maximum).Append("\n");
            sb.Append("  ResourceType: ").Append(ResourceType).Append("\n");
            sb.Append("  ResourceQuotas: ").Append(ResourceQuotas).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
