/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Represents the data transfer object (DTO) for RDS S3 WORM options.
    /// </summary>
    [DataContract(Name = "RdsS3WormOptionsDto")]
    public partial class RdsS3WormOptionsDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="RdsS3WormOptionsDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected RdsS3WormOptionsDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="RdsS3WormOptionsDto" /> class.
        /// </summary>
        /// <param name="bucketName">The name of the bucket associated with RDS S3 WORM. (required).</param>
        /// <param name="accessKeyRead">The access key for reading from the RDS S3 WORM bucket. (required).</param>
        /// <param name="secretKeyRead">The secret key for reading from the RDS S3 WORM bucket. (required).</param>
        /// <param name="accessKeyWrite">The access key for writing to the RDS S3 WORM bucket. (required).</param>
        /// <param name="secretKeyWrite">The secret key for writing to the RDS S3 WORM bucket. (required).</param>
        /// <param name="endpoint">The endpoint for the RDS S3 WORM bucket. (required).</param>
        /// <param name="size">size.</param>
        public RdsS3WormOptionsDto(string bucketName = default(string), string accessKeyRead = default(string), string secretKeyRead = default(string), string accessKeyWrite = default(string), string secretKeyWrite = default(string), string endpoint = default(string), QuotaDto size = default(QuotaDto))
        {
            // to ensure "bucketName" is required (not null)
            if (bucketName == null)
            {
                throw new ArgumentNullException("bucketName is a required property for RdsS3WormOptionsDto and cannot be null");
            }
            this.BucketName = bucketName;
            // to ensure "accessKeyRead" is required (not null)
            if (accessKeyRead == null)
            {
                throw new ArgumentNullException("accessKeyRead is a required property for RdsS3WormOptionsDto and cannot be null");
            }
            this.AccessKeyRead = accessKeyRead;
            // to ensure "secretKeyRead" is required (not null)
            if (secretKeyRead == null)
            {
                throw new ArgumentNullException("secretKeyRead is a required property for RdsS3WormOptionsDto and cannot be null");
            }
            this.SecretKeyRead = secretKeyRead;
            // to ensure "accessKeyWrite" is required (not null)
            if (accessKeyWrite == null)
            {
                throw new ArgumentNullException("accessKeyWrite is a required property for RdsS3WormOptionsDto and cannot be null");
            }
            this.AccessKeyWrite = accessKeyWrite;
            // to ensure "secretKeyWrite" is required (not null)
            if (secretKeyWrite == null)
            {
                throw new ArgumentNullException("secretKeyWrite is a required property for RdsS3WormOptionsDto and cannot be null");
            }
            this.SecretKeyWrite = secretKeyWrite;
            // to ensure "endpoint" is required (not null)
            if (endpoint == null)
            {
                throw new ArgumentNullException("endpoint is a required property for RdsS3WormOptionsDto and cannot be null");
            }
            this.Endpoint = endpoint;
            this.Size = size;
        }

        /// <summary>
        /// The name of the bucket associated with RDS S3 WORM.
        /// </summary>
        /// <value>The name of the bucket associated with RDS S3 WORM.</value>
        [DataMember(Name = "bucketName", IsRequired = true, EmitDefaultValue = true)]
        public string BucketName { get; set; }

        /// <summary>
        /// The access key for reading from the RDS S3 WORM bucket.
        /// </summary>
        /// <value>The access key for reading from the RDS S3 WORM bucket.</value>
        [DataMember(Name = "accessKeyRead", IsRequired = true, EmitDefaultValue = true)]
        public string AccessKeyRead { get; set; }

        /// <summary>
        /// The secret key for reading from the RDS S3 WORM bucket.
        /// </summary>
        /// <value>The secret key for reading from the RDS S3 WORM bucket.</value>
        [DataMember(Name = "secretKeyRead", IsRequired = true, EmitDefaultValue = true)]
        public string SecretKeyRead { get; set; }

        /// <summary>
        /// The access key for writing to the RDS S3 WORM bucket.
        /// </summary>
        /// <value>The access key for writing to the RDS S3 WORM bucket.</value>
        [DataMember(Name = "accessKeyWrite", IsRequired = true, EmitDefaultValue = true)]
        public string AccessKeyWrite { get; set; }

        /// <summary>
        /// The secret key for writing to the RDS S3 WORM bucket.
        /// </summary>
        /// <value>The secret key for writing to the RDS S3 WORM bucket.</value>
        [DataMember(Name = "secretKeyWrite", IsRequired = true, EmitDefaultValue = true)]
        public string SecretKeyWrite { get; set; }

        /// <summary>
        /// The endpoint for the RDS S3 WORM bucket.
        /// </summary>
        /// <value>The endpoint for the RDS S3 WORM bucket.</value>
        [DataMember(Name = "endpoint", IsRequired = true, EmitDefaultValue = true)]
        public string Endpoint { get; set; }

        /// <summary>
        /// Gets or Sets Size
        /// </summary>
        [DataMember(Name = "size", EmitDefaultValue = false)]
        public QuotaDto Size { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class RdsS3WormOptionsDto {\n");
            sb.Append("  BucketName: ").Append(BucketName).Append("\n");
            sb.Append("  AccessKeyRead: ").Append(AccessKeyRead).Append("\n");
            sb.Append("  SecretKeyRead: ").Append(SecretKeyRead).Append("\n");
            sb.Append("  AccessKeyWrite: ").Append(AccessKeyWrite).Append("\n");
            sb.Append("  SecretKeyWrite: ").Append(SecretKeyWrite).Append("\n");
            sb.Append("  Endpoint: ").Append(Endpoint).Append("\n");
            sb.Append("  Size: ").Append(Size).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
